{ **************************************************************************** }
{ *                                                                          * }
{ * GRAB MAN (unknown mfg, Game & Time) Simulator                            * }
{ * by Luca "MADrigal" Antignano, November 1999 (revision: August 2021)      * }
{ *                                                                          * }
{ * http://www.madrigaldesign.it/sim/                                        * }
{ * lucantignano@gmail.com                                                   * }
{ *                                                                          * }
{ * This source code (the "Software") is released as "open source" under the * }
{ * "Creative Common Attribution-NonCommercial-ShareAlike" license 4.0       * }
{ * available at:                                                            * }
{ * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode              * }
{ *                                                                          * }
{ * In addition to the constraints set by the CC license, you must respect   * }
{ * the following rules:                                                     * }
{ * a. do not offer the Software on a pay-per-play basis.                    * }
{ * b. do not distribute the Software through pre-paid access websites or    * }
{ *    BBS's.                                                                * }
{ * c. do not use the Software in publications of any form unless written    * }
{ *    consent is obtained by the author.                                    * }
{ * d. do not distribute the Software through mirror websites, unless        * }
{ *    written consent is obtained by the author.                            * }
{ * e. do not distribute older versions of the Software through authorized   * }
{ *    mirror websites after newer ones have been made available by the      * }
{ *    author.                                                               * }
{ *                                                                          * }
{ * Excerpt from the CC BY-NC-SA license 4.0                                 * }
{ * ========================================                                 * }
{ * BY: You must give appropriate credit, provide a link to the license, and * }
{ *     indicate if changes were made. You may do so in any reasonable       * }
{ *     manner, but not in any way that suggests the licensor endorses you   * }
{ *     or your use.                                                         * }
{ * NC: You may not use the material for commercial purposes.                * }
{ * SA: If you remix, transform, or build upon the material, you must        * }
{ *     distribute your contributions under the same license as the          * }
{ *     original.                                                            * }
{ *                                                                          * }
{ **************************************************************************** }

unit unit1;
{ this unit contains the main form implementation                              }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, Registry, Jpeg, Pngimage, Fmod, Fmodtypes, StdCtrls, Menus,
  ShellAPI;

type
  TForm1 = class(TForm)
{ * HANDHELD GRAPHICS, INCLUDING BUTTONS                                     * }

    // fullscreen mode items
    btn_game_menu_top:        TImage;
    btn_game_menu_background: TImage;

    im_backdrop:              TImage;
    im_backdrop_logo:         TImage;

    // electronic game
    im_background:            TImage;       im_background_screen_top: TImage;

    btn_mode_time:            TImage;       btn_mode_top:             TImage;
    btn_ama_down:             TImage;       btn_ama_top:              TImage;
    btn_pro_down:             TImage;       btn_pro_top:              TImage;
    btn_time_down:            TImage;       btn_time_top:             TImage;
                                            btn_set_top:              TImage;
                                            btn_halt_top:             TImage;

    btn_up_down:              TImage;       btn_up_top:               TImage;
    btn_left_down:            TImage;       btn_left_top:             TImage;
    btn_right_down:           TImage;       btn_right_top:            TImage;
    btn_down_down:            TImage;       btn_down_top:             TImage;

{ * LCD SCREEN GRAPHICS (SPRITES)                                            * }

    // on-screen panel (score, stage, bonus, etc.)
    im_panel_digit_1: TImage; im_panel_digit_2: TImage; im_panel_digit_3: TImage; im_panel_digit_4: TImage; im_panel_digit_5: TImage; im_panel_digit_6: TImage; im_panel_digit_7: TImage; im_panel_digit_8: TImage;

    im_panel_number_0: TImage; im_panel_number_1: TImage; im_panel_number_2: TImage; im_panel_number_3: TImage; im_panel_number_4: TImage;
    im_panel_number_5: TImage; im_panel_number_6: TImage; im_panel_number_7: TImage; im_panel_number_8: TImage; im_panel_number_9: TImage;

    im_panel_letter_a: TImage; im_panel_letter_d: TImage; im_panel_letter_o: TImage; im_panel_letter_p: TImage;

    im_panel_lives_1: TImage; im_panel_lives_2: TImage; im_panel_lives_3: TImage;

    im_panel_time_pm: TImage; im_panel_over: TImage;

    // on-screen items
    im_pacman_01_01: TImage; im_pacman_01_02: TImage;                                                                                                     im_pacman_01_07: TImage; im_pacman_01_08: TImage;
    im_pacman_02_01: TImage; im_pacman_02_02: TImage; im_pacman_02_03: TImage; im_pacman_02_04: TImage; im_pacman_02_05: TImage; im_pacman_02_06: TImage; im_pacman_02_07: TImage; im_pacman_02_08: TImage;
    im_pacman_03_01: TImage; im_pacman_03_02: TImage; im_pacman_03_03: TImage;                                                   im_pacman_03_06: TImage; im_pacman_03_07: TImage; im_pacman_03_08: TImage;
    im_pacman_04_01: TImage; im_pacman_04_02: TImage; im_pacman_04_03: TImage; im_pacman_04_04: TImage; im_pacman_04_05: TImage; im_pacman_04_06: TImage; im_pacman_04_07: TImage; im_pacman_04_08: TImage;
    im_pacman_05_01: TImage; im_pacman_05_02: TImage; im_pacman_05_03: TImage; im_pacman_05_04: TImage; im_pacman_05_05: TImage; im_pacman_05_06: TImage; im_pacman_05_07: TImage; im_pacman_05_08: TImage;

    im_ghost_01_01: TImage; im_ghost_01_02: TImage;                                                                                                 im_ghost_01_07: TImage; im_ghost_01_08: TImage;
    im_ghost_02_01: TImage; im_ghost_02_02: TImage; im_ghost_02_03: TImage; im_ghost_02_04: TImage; im_ghost_02_05: TImage; im_ghost_02_06: TImage; im_ghost_02_07: TImage; im_ghost_02_08: TImage;
    im_ghost_03_01: TImage; im_ghost_03_02: TImage; im_ghost_03_03: TImage;                                                 im_ghost_03_06: TImage; im_ghost_03_07: TImage; im_ghost_03_08: TImage;
    im_ghost_04_01: TImage; im_ghost_04_02: TImage; im_ghost_04_03: TImage; im_ghost_04_04: TImage; im_ghost_04_05: TImage; im_ghost_04_06: TImage; im_ghost_04_07: TImage; im_ghost_04_08: TImage;
    im_ghost_05_01: TImage; im_ghost_05_02: TImage; im_ghost_05_03: TImage; im_ghost_05_04: TImage; im_ghost_05_05: TImage; im_ghost_05_06: TImage; im_ghost_05_07: TImage; im_ghost_05_08: TImage;

    im_ghost_pit_3: TImage; im_ghost_pit_2: TImage; im_ghost_pit_1: TImage;

    im_pill_01_01_double: TImage;                                                                                                                                                       im_pill_01_07_power: TImage;
                                  im_pill_02_02_single: TImage;                               im_pill_02_04_single: TImage;                               im_pill_02_06_single: TImage;                               im_pill_02_08_single: TImage;
    im_pill_03_01_double: TImage;                                                                                           im_cherry: TImage;                                          im_pill_03_07_double: TImage;
                                  im_pill_04_02_single: TImage;                               im_pill_04_04_single: TImage;                               im_pill_04_06_single: TImage;                               im_pill_04_08_single: TImage;
    im_pill_05_01_power: TImage;                                im_pill_05_03_single: TImage;                               im_pill_05_05_single: TImage;                               im_pill_05_07_double: TImage;

{ * TIMERS                                                                   * }
    Timer_Cherry_Bonus:     TTimer;
    Timer_Clock:            TTimer;
    Timer_Game:             TTimer;
    Timer_Game_Start:       TTimer;
    Timer_Ghost_Bonus:      TTimer;
    Timer_Intermission:     TTimer;
    Timer_Miss:             TTimer;
    Timer_Power_Pill_Sound: TTimer;
    Timer_Stage_Complete:   TTimer;

{ * POPUP MENU                                                               * }
    pm_0_menu:          TPopupMenu;
    pm_1_about:         TMenuItem;
    pm_2_readme:        TMenuItem;
    pm_3_whatsnew:      TMenuItem;
    pm_4_manual:        TMenuItem;
    pm_5_n1:            TMenuItem;
    pm_6_config:        TMenuItem;
    pm_7_keys:          TMenuItem;
    pm_8_hiscore:       TMenuItem;
    pm_9_n2:            TMenuItem;
  {}pm_10_fullscreen:   TMenuItem;
  {}pm_11_splashscreen: TMenuItem;
{}//pm_12_controller:   TMenuItem; (not required)
  {}pm_13_n3:           TMenuItem;
  {}pm_14_exit:         TMenuItem;

{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
    procedure FormCreate                    (Sender: TObject);
    procedure FormActivate                  (Sender: TObject);
    procedure FormClose                     (Sender: TObject; var Action: TCloseAction);

{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
    procedure Vid_Show_All                  (b: boolean);

    procedure Vid_Show_All_Ghosts           (b: boolean);
    procedure Vid_Show_All_Ghosts_Pit       (b: boolean);
    procedure Vid_Show_All_Pacman           (b: boolean);
    procedure Vid_Show_All_Pills            (b: boolean);

    procedure Vid_Show_Ghost                (p: integer; b: boolean);
    procedure Vid_Show_Ghost_Pit            (p: integer; b: boolean);
    procedure Vid_Show_Pacman               (b: boolean);

    procedure Vid_Show_Panel_Lives          (var p: integer);
    procedure Vid_Show_Panel_Score          (var p: integer; b: boolean);
    procedure Vid_Show_Panel_Score_Bonus    (var p: integer; b: boolean);
    procedure Vid_Show_Panel_Stage;

{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
    procedure Snd_Play                      (pfs: PFSoundSample);
    procedure Snd_Silence;

{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
    procedure im_backgroundMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure im_backgroundMouseMove        (Sender: TObject;                       Shift: TShiftState; X, Y: Integer);

    procedure btn_mode_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_ama_topMouseDown          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ama_topMouseUp            (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_pro_topMouseDown          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_pro_topMouseUp            (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_time_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_time_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_up_topMouseDown           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_up_topMouseUp             (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_left_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_left_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_right_topMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_right_topMouseUp          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_down_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_down_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormKeyDown                   (Sender: TObject; var Key: Word;        Shift: TShiftState);
    procedure FormKeyUp                     (Sender: TObject; var Key: Word;        Shift: TShiftState);

{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
    procedure Inp_ama_down;                 procedure Inp_ama_up;
    procedure Inp_pro_down;                 procedure Inp_pro_up;
    procedure Inp_time_down;                procedure Inp_time_up;
    procedure Inp_mode_down;

    procedure Inp_up_down;                  procedure Inp_up_up;
    procedure Inp_left_down;                procedure Inp_left_up;
    procedure Inp_right_down;               procedure Inp_right_up;
    procedure Inp_down_down;                procedure Inp_down_up;

{ * PROCEDURES: GAME ROUTINES                                                * }
    procedure Gam_Stop_All_Timers;

    procedure Gam_Add_Bonus_Life;
    procedure Gam_Calculate_Cherry_Value;
    procedure Gam_Game_Over;
    procedure Gam_Ghosts_Move;
    procedure Gam_Ghosts_Pit_Move;
    procedure Gam_Pacman_Eats;
    procedure Gam_Set_Mode;
    procedure Gam_Set_New_Maze_Ghosts;
    procedure Gam_Set_New_Maze_Pills;

{ * PROCEDURES: TIMERS                                                       * }
    procedure Timer_Cherry_BonusTimer       (Sender: TObject);
    procedure Timer_ClockTimer              (Sender: TObject);
    procedure Timer_GameTimer               (Sender: TObject);
    procedure Timer_Game_StartTimer         (Sender: TObject);
    procedure Timer_Ghost_BonusTimer        (Sender: TObject);
    procedure Timer_IntermissionTimer       (Sender: TObject);
    procedure Timer_MissTimer               (Sender: TObject);
    procedure Timer_Power_Pill_SoundTimer   (Sender: TObject);
    procedure Timer_Stage_CompleteTimer     (Sender: TObject);

{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
    procedure pm_0_menuPopup                (Sender: TObject);
    procedure pm_1_aboutClick               (Sender: TObject);
    procedure pm_2_readmeClick              (Sender: TObject);
    procedure pm_3_whatsnewClick            (Sender: TObject);
    procedure pm_4_manualClick              (Sender: TObject);
    procedure pm_6_configClick              (Sender: TObject);
    procedure pm_7_keysClick                (Sender: TObject);
    procedure pm_8_hiscoreClick             (Sender: TObject);
  {}procedure pm_10_fullscreenClick         (Sender: TObject);
  {}procedure pm_11_splashscreenClick       (Sender: TObject);
{}//procedure pm_12_controllerClick         (Sender: TObject);
  {}procedure pm_14_exitClick               (Sender: TObject);

{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
    procedure btn_game_menu_topClick        (Sender: TObject);

    procedure la_menu_itemMouseEnter        (Sender: TObject);
    procedure la_menu_itemMouseLeave        (Sender: TObject);
    procedure la_menu_itemMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure Vid_Display_Game_Menu         (b: boolean);
  end;

const
{ introduced for use with HH2 / now incorporated into main source }

  HH2_CONTENT_NAME    = 'Grab Man (unknown mfg, Game & Time)';
  HH2_CONTENT_AUTHOR  = 'Luca "MADrigal" Antignano';
  HH2_CONTENT_EMAIL   = 'lucantignano@gmail.com';
  HH2_CONTENT_VERSION = '5.00';
  HH2_CONTENT_DATE    = '2017/12/04';
  HH2_CONTENT_WEBSITE = 'www.madrigaldesign.it/sim';

  { constants for all builds }
  
  APP_NAME    = HH2_CONTENT_NAME + ' Simulator';                                // application's name (appears on taskbar and Splash screen)
{}APP_VERSION = 'Version ' + HH2_CONTENT_VERSION + ' * Final *';                // current version (appears on Splash screen)
{}APP_DATE    = 'Released by ' + HH2_CONTENT_AUTHOR + ' on 4th December, 2017'; // release date (appears on Splash screen)

  URL_EMAIL   = 'mailto:' + HH2_CONTENT_EMAIL;                                  // link to the email address
  URL_PAYPAL  = 'https://www.paypal.me/LucaAntignano';                          // link to the Paypal donation page
  URL_WEBSITE = 'http://' + HH2_CONTENT_WEBSITE + '/';                          // link to the website

  REG_KEY        = 'Software\MADrigal\GrabMan50';                               // registry key

  HINT_CLICK     = 'click or press';
  HINT_AMA       = 'to start Amateur game';
  HINT_PRO       = 'to start Professional game';
  HINT_TIME      = 'to view current time';
  HINT_MODE_TIME = 'to switch to game mode';
  HINT_MODE_GAME = 'to switch to time mode';
  HINT_SET       = 'button disabled';
  HINT_HALT      = 'button disabled';

{}MENU_ITEMS = 13;
  NUM_KEYS = 8;

var
{ * main objects * }
  Form1:                   TForm1;                                              // main form
  bStartup:                boolean;                                             // manages splash screen at startup
  iMouseX, iMouseY:        integer;                                             // cursor coordinates (to drag main form)
  iReg:                    TRegIniFile;                                         // system registry (to save high-scores)

{ * sound management * }
  pfs_beep,
  pfs_bonus,
  pfs_miss,
  pfs_point,
  pfs_start:               PFSoundSample;                                       // sound samples

  bSound:                  boolean;                                             // sound enabled? (depending on selected driver on splash screen)

{ * arrays of images * }
  aIm_panel_digit_pos:     array[1..8]       of TImage;                         // empty sprites to host score/time/messages digits
  aIm_panel_number:        array[0..13]      of TImage;                         // digits for score/time + characters for special messages
  aIm_panel_lives:         array[1..3]       of TImage;                         // digits for lives left

  aIm_pacman,                                                                   // Pac Man: x=row; y=column
  aIm_ghost,                                                                    // ghosts:  x=row; y=column
  aIm_pill:                array[1..5, 1..8] of TImage;                         // pills:   x=row; y=column
  aIm_ghost_pit:           array[0..3]       of TImage;                         // ghosts in their pit: x=column (0=outside)

{ * arrays of integers, booleans and records * }
  aMaze:                   array[1..5, 1..8] of record
                                                  d,
                                                  l,
                                                  r,
                                                  u  : boolean;
                                                end;

  aPill:                   array[1..5, 1..8] of integer;

  rGhost:                  array[1..3]       of record
                                                  x,
                                                  y,
                                                  iStatus : integer;            // 0=disabled; 1=in pit (right); 2=in pit (center); 3=in pit (left); 4=in maze (chasing); 5=in maze (escaping);
                                                end;

  aGhost_Pit:              array[1..3]       of integer;                        // ghosts in their pit: x=ghost id

{ * arrays of mixed types *}
  aKeys:                   array[1..NUM_KEYS] of record                         // keys management (values)
                                                   int:  integer;
                                                   word: word;
                                                 end;

  aKeyHints:               array[1..44] of string;                              // keys management (hint on buttons)

  aMenuItem:               array[1..MENU_ITEMS] of TMenuItem;                   // popup menu items
  aMenuLabels:             array[1..MENU_ITEMS] of TLabel;                      // on-screen game menu labels

{ * integers and booleans * }
  iMode,                                                                        // 1=time (switch); 2=demo (switch); 3=ama game start; 4=ama game; 5=pro game start; 6=pro game; 7=time (with demo switch); 8=game over
  iPacmanX, iPacmanY,                                                           // x=1-5; y=1-8
  iScore,                                                                       // 0-999,999
  iHiScoreA,                                                                    // 0-999,999 (ama)
  iHiScoreP,                                                                    // 0-999,999 (pro)
  iScoreCherry,                                                                 // 200-2,000
  iScoreGhost,                                                                  // 200-800
  iScoreBonusLife,                                                              // 5,000 and at every 20,000
  iLives,                                                                       // 0-3
  iStage,                                                                       // 1-99
  iPillsLeftForStage,                                                           // 0-290 (10*5 + 4*10 + 2*100)
  iPillsLeftForCherry                                                           // 0-8
                         : integer;

{}bFullscreenMode,                                                              // true if video mode is fullscreen (false if "shaped game")
  bGameMenuOpen,                                                                // true if the on-screen menu is visible

  bControls,
  bLeftPressed,
  bRightPressed,
  bUpPressed,
  bDownPressed
                         : boolean;

  // Game variables: loops
  iLoopCherryBonus,
  iLoopGameCherry,                                                              // 1-75 (appears at 0, disappears at 90 then stop)
  iLoopGameGhost,                                                               // 1-7  (action occurs when value is 7)
  iLoopGameGhostPit,                                                            // 1-14 (action occurs when value is 8)
  iLoopGamePacman,                                                              // 1-6  (action occurs when value is 6)
  iLoopGamePowerPill,                                                           // 1-57 (power pill ends at 58)
  iLoopGameStart,
  iLoopGhostBonus,
  iLoopGhostBonusIndex,
  iLoopIntermission,
  iLoopMiss,
  iLoopStageComplete
                         : integer;

implementation

uses
  about, gfxinit, keys, manual, splash;

{$r *.dfm}










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
{ sprites on form are associated to arrays of images, needed to "index" them   }
{ variables are initialized: system registry, randomize, game mode, etc.       }
  var
    i: integer;
begin
  // initializes application name (for Windows taskbar)
  Application.Title := APP_NAME;

{}// sets game off the screen while graphics initialise
{}Top  := - Screen.Height;
{}Left := - Screen.Width;

  // on-screen panel
  aIm_panel_digit_pos[1] := im_panel_digit_1; aIm_panel_digit_pos[2] := im_panel_digit_2; aIm_panel_digit_pos[3] := im_panel_digit_3; aIm_panel_digit_pos[4] := im_panel_digit_4; aIm_panel_digit_pos[5] := im_panel_digit_5; aIm_panel_digit_pos[6] := im_panel_digit_6; aIm_panel_digit_pos[7] := im_panel_digit_7; aIm_panel_digit_pos[8] := im_panel_digit_8;

  // numbers
  aIm_panel_number[0] := im_panel_number_0; aIm_panel_number[1] := im_panel_number_1; aIm_panel_number[2] := im_panel_number_2; aIm_panel_number[3] := im_panel_number_3; aIm_panel_number[4] := im_panel_number_4; aIm_panel_number[5] := im_panel_number_5; aIm_panel_number[6] := im_panel_number_6; aIm_panel_number[7] := im_panel_number_7; aIm_panel_number[8] := im_panel_number_8; aIm_panel_number[9] := im_panel_number_9;

  aIm_panel_number[10] := im_panel_letter_a;
  aIm_panel_number[11] := im_panel_letter_d;
  aIm_panel_number[12] := im_panel_letter_o;
  aIm_panel_number[13] := im_panel_letter_p;

  aIm_panel_lives[1] := im_panel_lives_1; aIm_panel_lives[2] := im_panel_lives_2; aIm_panel_lives[3] := im_panel_lives_3;

  // on-screen items
  aIm_pacman[1, 1] := im_pacman_01_01;    aIm_pacman[1, 2] := im_pacman_01_02;    {                                  }    {                                  }    {                                  }    {                                  }    aIm_pacman[1, 7] := im_pacman_01_07;    aIm_pacman[1, 8] := im_pacman_01_08;
  aIm_pacman[2, 1] := im_pacman_02_01;    aIm_pacman[2, 2] := im_pacman_02_02;    aIm_pacman[2, 3] := im_pacman_02_03;    aIm_pacman[2, 4] := im_pacman_02_04;    aIm_pacman[2, 5] := im_pacman_02_05;    aIm_pacman[2, 6] := im_pacman_02_06;    aIm_pacman[2, 7] := im_pacman_02_07;    aIm_pacman[2 ,8] := im_pacman_02_08;
  aIm_pacman[3, 1] := im_pacman_03_01;    aIm_pacman[3, 2] := im_pacman_03_02;    aIm_pacman[3, 3] := im_pacman_03_03;    {                                  }    {                                  }    aIm_pacman[3, 6] := im_pacman_03_06;    aIm_pacman[3, 7] := im_pacman_03_07;    aIm_pacman[3, 8] := im_pacman_03_08;
  aIm_pacman[4, 1] := im_pacman_04_01;    aIm_pacman[4, 2] := im_pacman_04_02;    aIm_pacman[4, 3] := im_pacman_04_03;    aIm_pacman[4, 4] := im_pacman_04_04;    aIm_pacman[4, 5] := im_pacman_04_05;    aIm_pacman[4, 6] := im_pacman_04_06;    aIm_pacman[4, 7] := im_pacman_04_07;    aIm_pacman[4, 8] := im_pacman_04_08;
  aIm_pacman[5, 1] := im_pacman_05_01;    aIm_pacman[5, 2] := im_pacman_05_02;    aIm_pacman[5, 3] := im_pacman_05_03;    aIm_pacman[5, 4] := im_pacman_05_04;    aIm_pacman[5, 5] := im_pacman_05_05;    aIm_pacman[5, 6] := im_pacman_05_06;    aIm_pacman[5, 7] := im_pacman_05_07;    aIm_pacman[5, 8] := im_pacman_05_08;

  aIm_ghost[1, 1] := im_ghost_01_01;      aIm_ghost[1, 2] := im_ghost_01_02;      {                                }      {                                }      {                                }      {                                }      aIm_ghost[1, 7] := im_ghost_01_07;      aIm_ghost[1, 8] := im_ghost_01_08;
  aIm_ghost[2, 1] := im_ghost_02_01;      aIm_ghost[2, 2] := im_ghost_02_02;      aIm_ghost[2, 3] := im_ghost_02_03;      aIm_ghost[2, 4] := im_ghost_02_04;      aIm_ghost[2, 5] := im_ghost_02_05;      aIm_ghost[2, 6] := im_ghost_02_06;      aIm_ghost[2, 7] := im_ghost_02_07;      aIm_ghost[2, 8] := im_ghost_02_08;
  aIm_ghost[3, 1] := im_ghost_03_01;      aIm_ghost[3, 2] := im_ghost_03_02;      aIm_ghost[3, 3] := im_ghost_03_03;      {                                }      {                                }      aIm_ghost[3, 6] := im_ghost_03_06;      aIm_ghost[3, 7] := im_ghost_03_07;      aIm_ghost[3, 8] := im_ghost_03_08;
  aIm_ghost[4, 1] := im_ghost_04_01;      aIm_ghost[4, 2] := im_ghost_04_02;      aIm_ghost[4, 3] := im_ghost_04_03;      aIm_ghost[4, 4] := im_ghost_04_04;      aIm_ghost[4, 5] := im_ghost_04_05;      aIm_ghost[4, 6] := im_ghost_04_06;      aIm_ghost[4, 7] := im_ghost_04_07;      aIm_ghost[4, 8] := im_ghost_04_08;
  aIm_ghost[5, 1] := im_ghost_05_01;      aIm_ghost[5, 2] := im_ghost_05_02;      aIm_ghost[5, 3] := im_ghost_05_03;      aIm_ghost[5, 4] := im_ghost_05_04;      aIm_ghost[5, 5] := im_ghost_05_05;      aIm_ghost[5, 6] := im_ghost_05_06;      aIm_ghost[5, 7] := im_ghost_05_07;      aIm_ghost[5, 8] := im_ghost_05_08;

  aIm_pill[1, 1] := im_pill_01_01_double; {                                     } {                                     } {                                     } {                                     } {                                     } aIm_pill[1, 7] := im_pill_01_07_power;  {                                     }
  {                                     } aIm_pill[2, 2] := im_pill_02_02_single; {                                     } aIm_pill[2, 4] := im_pill_02_04_single; {                                     } aIm_pill[2, 6] := im_pill_02_06_single; {                                     } aIm_pill[2, 8] := im_pill_02_08_single;
  aIm_pill[3, 1] := im_pill_03_01_double; {                                     } {                                     } {                                     } {                                     } {                                     } aIm_pill[3, 7] := im_pill_03_07_double; {                                     }
  {                                     } aIm_pill[4, 2] := im_pill_04_02_single; {                                     } aIm_pill[4, 4] := im_pill_04_04_single; {                                     } aIm_pill[4, 6] := im_pill_04_06_single; {                                     } aIm_pill[4, 8] := im_pill_04_08_single;
  aIm_pill[5, 1] := im_pill_05_01_power;  {                                     } aIm_pill[5, 3] := im_pill_05_03_single; {                                     } aIm_pill[5, 5] := im_pill_05_05_single; {                                     } aIm_pill[5, 7] := im_pill_05_07_double; {                                     }

  aIm_ghost_pit[0] := nil; aIm_ghost_pit[1] := im_ghost_pit_1; aIm_ghost_pit[2] := im_ghost_pit_2; aIm_ghost_pit[3] := im_ghost_pit_3;

  // maze
  with aMaze[1, 1] do begin u := false; d := true;  l := false; r := true;  end; with aMaze[1, 2] do begin u := false; d := true;  l := true;  r := false; end;                                                                                                                                                                                                                                                                                                                             with aMaze[1, 7] do begin u := false; d := true;  l := false; r := true;  end; with aMaze[1, 8] do begin u := false; d := true;  l := true;  r := false; end;
  with aMaze[2, 1] do begin u := true;  d := true;  l := true;  r := false; end; with aMaze[2, 2] do begin u := true;  d := false; l := false; r := true;  end; with aMaze[2, 3] do begin u := false; d := true;  l := true;  r := true;  end; with aMaze[2, 4] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[2, 5] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[2, 6] do begin u := false; d := true;  l := true;  r := true;  end; with aMaze[2, 7] do begin u := true;  d := false; l := true;  r := false; end; with aMaze[2, 8] do begin u := true;  d := true;  l := false; r := true;  end;
  with aMaze[3, 1] do begin u := true;  d := true;  l := false; r := true;  end; with aMaze[3, 2] do begin u := false; d := true;  l := true;  r := false; end; with aMaze[3, 3] do begin u := true;  d := true;  l := false; r := false; end;                                                                                                                                                               with aMaze[3, 6] do begin u := true;  d := true;  l := false; r := false; end; with aMaze[3, 7] do begin u := false; d := true;  l := false; r := true;  end; with aMaze[3, 8] do begin u := true;  d := true;  l := true;  r := false; end;
  with aMaze[4, 1] do begin u := true;  d := true;  l := true;  r := false; end; with aMaze[4, 2] do begin u := true;  d := false; l := false; r := true;  end; with aMaze[4, 3] do begin u := true;  d := true;  l := true;  r := true;  end; with aMaze[4, 4] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[4, 5] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[4, 6] do begin u := true;  d := true;  l := true;  r := true;  end; with aMaze[4, 7] do begin u := true;  d := false; l := true;  r := false; end; with aMaze[4, 8] do begin u := true;  d := true;  l := false; r := true;  end;
  with aMaze[5, 1] do begin u := true;  d := false; l := false; r := true;  end; with aMaze[5, 2] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[5, 3] do begin u := true;  d := false; l := true;  r := true;  end; with aMaze[5, 4] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[5, 5] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[5, 6] do begin u := true;  d := false; l := true;  r := true;  end; with aMaze[5, 7] do begin u := false; d := false; l := true;  r := true;  end; with aMaze[5, 8] do begin u := true;  d := false; l := true;  r := false; end;

  // registry keys management
  iReg := TregIniFile.Create(REG_KEY);                                          // system registry init

{}// init graphics
{}bFullscreenMode := iReg.ReadBool('', 'FullscreenMode', true);
{}pm_10_fullscreen.Checked := bFullscreenMode;
{}Gfxinit.Gfx_Game_Init;
{}bGameMenuOpen := false;

{}// initialises the "hints" array
  for i := 1 to 10 do
    aKeyHints[i] := '''' + Chr(i + 47) + '''';

  for i := 11 to 36 do
    aKeyHints[i] := '''' + Chr(i + 54) + '''';

  aKeyHints[37] := '''up arrow'' key';
  aKeyHints[38] := '''down arrow'' key';
  aKeyHints[39] := '''left arrow'' key';
  aKeyHints[40] := '''right arrow'' key';
  aKeyHints[41] := '''alt'' key';
  aKeyHints[42] := '''ctrl'' key';
  aKeyHints[43] := '''shift'' key';
  aKeyHints[44] := '''spacebar''';

  // reads values from system registry into the inputs array
  aKeys[1].int := iReg.ReadInteger('', 'Key1', 2);                              // "Ama"   (default: "1")
  aKeys[2].int := iReg.ReadInteger('', 'Key2', 3);                              // "Pro"   (default: "2")
  aKeys[3].int := iReg.ReadInteger('', 'Key3', 4);                              // "Time"  (default: "3")
  aKeys[4].int := iReg.ReadInteger('', 'Key4', 6);                              // "Mode"  (default: "5")
  aKeys[5].int := iReg.ReadInteger('', 'Key5', 37);                             // "Up"    (default: "UP")
  aKeys[6].int := iReg.ReadInteger('', 'Key6', 39);                             // "Left"  (default: "LEFT")
  aKeys[7].int := iReg.ReadInteger('', 'Key7', 40);                             // "Right" (default: "RIGHT")
  aKeys[8].int := iReg.ReadInteger('', 'Key8', 38);                             // "Down"  (default: "DOWN")

  // writes values into the system registry (in case no pre-existing values
  // stored), then assigns key values to the key-inputs array
  for i := 1 to NUM_KEYS do
    begin
      iReg.WriteInteger('', 'Key' + inttostr(i), aKeys[i].int);
      KeysForm.AssignWord(i, aKeys[i].int);
    end;

  // sets button images hints
  btn_mode_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int] + ' ' + HINT_MODE_TIME; // "Time switch"
  btn_ama_top.Hint   := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_AMA;  // "Ama"
  btn_pro_top.Hint   := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int] + ' ' + HINT_PRO;  // "Pro"
  btn_time_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[3].int] + ' ' + HINT_TIME; // "Time"
  btn_set_top.Hint   := HINT_SET;                                                     // "Set"
  btn_halt_top.Hint  := HINT_HALT;                                                    // "Halt"

  btn_up_top.Hint    := HINT_CLICK + ' ' + aKeyHints[aKeys[5].int];                   // "Up"
  btn_left_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[6].int];                   // "Left"
  btn_right_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[7].int];                   // "Right"
  btn_down_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[8].int];                   // "Down"

  // popup menu array association
  aMenuItem[1]  := pm_1_about;
  aMenuItem[2]  := pm_2_readme;
  aMenuItem[3]  := pm_3_whatsnew;
  aMenuItem[4]  := pm_4_manual;
  aMenuItem[5]  := pm_5_n1;
  aMenuItem[6]  := pm_6_config;
  aMenuItem[7]  := pm_7_keys;
  aMenuItem[8]  := pm_8_hiscore;
  aMenuItem[9]  := pm_9_n2;
{}aMenuItem[10] := pm_10_fullscreen;
{}aMenuItem[11] := pm_11_splashscreen;
{}//               pm_12_controller;
{}aMenuItem[12] := pm_13_n3;
{}aMenuItem[13] := pm_14_exit;

  // variables init
  DoubleBuffered := true;                                                       // enables double buffering for rendering of "form1"

  iHiScoreA := iReg.ReadInteger('', 'HiScore1', iHiScoreA);                     // reads value from system registry into iHiScoreA
  iHiScoreP := iReg.ReadInteger('', 'HiScore2', iHiScoreP);                     // reads value from system registry into iHiScoreP

  bControls := false;                                                           // prevents hero movement

  bDownPressed := false;
  bLeftPressed := false;
  bRightPressed := false;
  bUpPressed := false;

  Randomize;                                                                    // initializes the random number generator
end;





procedure TForm1.FormActivate(Sender: TObject);
{ sends focus to the splash screen at startup                                  }
begin
  if bStartup then
    begin
      bStartup := false;
      SplashForm.Show;
    end;
end;





procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
{ frees memory before shutting down                                            }
begin
  FSOUND_Sample_Free(pfs_beep);  FSOUND_Sample_Free(pfs_bonus);
  FSOUND_Sample_Free(pfs_miss);  FSOUND_Sample_Free(pfs_point);
  FSOUND_Sample_Free(pfs_start);

  FSOUND_Close;

{}iReg.Destroy;
  Action := caFree;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Vid_Show_All(b: boolean);
{ displays/hides all sprites (including the score/time panel)                  }
  var
    i: integer;
begin
  Vid_Show_All_Ghosts(b);
  Vid_Show_All_Ghosts_Pit(b);
  Vid_Show_All_Pacman(b);
  Vid_Show_All_Pills(b);

  im_cherry.Visible := b;

  im_panel_time_pm.Visible := b;
  im_panel_over.Visible := b;

  for i := 1 to 8 do
    aIm_panel_digit_pos[i].Visible := true;

  if not b then
    for i := 1 to 8 do
      aIm_panel_digit_pos[i].Picture := nil;
end;





procedure TForm1.Vid_Show_All_Ghosts(b: boolean);
{ displays/hides all the ghosts in the maze (excluding those in pit)           }
  var
    i: integer;
begin
  for i := 1 to 2 do aIm_ghost[1, i].Visible := b;
  for i := 7 to 8 do aIm_ghost[1, i].Visible := b;
  for i := 1 to 8 do aIm_ghost[2, i].Visible := b;
  for i := 1 to 3 do aIm_ghost[3, i].Visible := b;
  for i := 6 to 8 do aIm_ghost[3, i].Visible := b;
  for i := 1 to 8 do aIm_ghost[4, i].Visible := b;
  for i := 1 to 8 do aIm_ghost[5, i].Visible := b;
end;





procedure TForm1.Vid_Show_All_Ghosts_Pit(b: boolean);
{ displays/hides all the ghosts in the pit                                     }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_ghost_pit[i].Visible := b;
end;





procedure TForm1.Vid_Show_All_Pacman(b: boolean);
{ displays/hides all the Pac Mans                                              }
  var
    i: integer;
begin
  for i := 1 to 2 do aIm_pacman[1, i].Visible := b;
  for i := 7 to 8 do aIm_pacman[1, i].Visible := b;
  for i := 1 to 8 do aIm_pacman[2, i].Visible := b;
  for i := 1 to 3 do aIm_pacman[3, i].Visible := b;
  for i := 6 to 8 do aIm_pacman[3, i].Visible := b;
  for i := 1 to 8 do aIm_pacman[4, i].Visible := b;
  for i := 1 to 8 do aIm_pacman[5, i].Visible := b;
end;





procedure TForm1.Vid_Show_All_Pills(b: boolean);
{ displays/hides all pills (single, double, power) - excluding cherry          }
begin
  aIm_pill[1, 1].Visible := b;                                                                                                                                                  aIm_pill[1, 7].Visible := b;
                               aIm_pill[2, 2].Visible := b;                              aIm_pill[2, 4].Visible := b;                              aIm_pill[2, 6].Visible := b;                              aIm_pill[2, 8].Visible := b;
  aIm_pill[3, 1].Visible := b;                                                                                                                                                  aIm_pill[3, 7].Visible := b;
                               aIm_pill[4, 2].Visible := b;                              aIm_pill[4, 4].Visible := b;                              aIm_pill[4, 6].Visible := b;                              aIm_pill[4, 8].Visible := b;
  aIm_pill[5, 1].Visible := b;                              aIm_pill[5, 3].Visible := b;                              aIm_pill[5, 5].Visible := b;                              aIm_pill[5, 7].Visible := b;
end;





procedure TForm1.Vid_Show_Ghost(p: integer; b: boolean);
{ displays/hides ghost. p=which ghost (1-3). b=show/hide                       }
begin
  aIm_ghost[rGhost[p].y, rGhost[p].x].Visible := b;
end;





procedure TForm1.Vid_Show_Ghost_Pit(p: integer; b: boolean);
{ displays/hides ghost. p=which ghost (1-3). b=show/hide                       }
begin
  aIm_ghost_pit[p].Visible := b;
end;





procedure TForm1.Vid_Show_Pacman(b: boolean);
{ displays/hides Pac Man. b=show/hide                                          }
begin
  aIm_pacman[iPacmanY, iPacmanX].Visible := b;
end;





procedure TForm1.Vid_Show_Panel_Lives(var p: integer);
{ displays number of lives left in the form of a symbol                        }
begin
  if p > 0 then
    aIm_panel_digit_pos[2].Picture := aIm_panel_lives[p].Picture
  else
    aIm_panel_digit_pos[2].Picture := nil;
end;





procedure TForm1.Vid_Show_Panel_Score(var p: integer; b: boolean);
{ transforms score/high-score into sprites, and displays/hides them            }
  var
    i, t: integer;
begin
  t := p;

  while t >= 1000000 do                                                         // displays "1000000" as "...0"
    Dec(t, 1000000);

  if b then                                                                     // display or hide score/high-score?
    begin                                                                         // display
      aIm_panel_digit_pos[3].Picture := aIm_panel_number[t div 100000 mod 10].Picture; // hundred thousands
      aIm_panel_digit_pos[4].Picture := aIm_panel_number[t div  10000 mod 10].Picture; // tens thousands
      aIm_panel_digit_pos[5].Picture := aIm_panel_number[t div   1000 mod 10].Picture; // thousands
      aIm_panel_digit_pos[6].Picture := aIm_panel_number[t div    100 mod 10].Picture; // hundreds
      aIm_panel_digit_pos[7].Picture := aIm_panel_number[t div     10 mod 10].Picture; // tens
      aIm_panel_digit_pos[8].Picture := aIm_panel_number[t            mod 10].Picture; // units
    end
  else                                                                            // hide
    for i := 3 to 8 do
      aIm_panel_digit_pos[i].Picture := nil;
end;





procedure TForm1.Vid_Show_Panel_Score_Bonus(var p: integer; b: boolean);
{ transforms bonus points into sprites, and displays/hides them                }
  var
    i: integer;
begin
  if b then                                                                     // display or hide score?
    begin                                                                         // display
                      aIm_panel_digit_pos[1].Picture := nil;
                      aIm_panel_digit_pos[2].Picture := nil;
                      aIm_panel_digit_pos[3].Picture := nil;
                      aIm_panel_digit_pos[4].Picture := nil;
      if p > 999 then aIm_panel_digit_pos[5].Picture := aIm_panel_number[p div 1000 mod 10].Picture else aIm_panel_digit_pos[5].Picture := nil; // thousands
      if p >  99 then aIm_panel_digit_pos[6].Picture := aIm_panel_number[p div  100 mod 10].Picture else aIm_panel_digit_pos[6].Picture := nil; // hundreds
      if p >   9 then aIm_panel_digit_pos[7].Picture := aIm_panel_number[p div   10 mod 10].Picture else aIm_panel_digit_pos[7].Picture := nil; // tens
                      aIm_panel_digit_pos[8].Picture := aIm_panel_number[p          mod 10].Picture;                                            // units
    end
  else                                                                            // hide
    for i := 1 to 8 do
      aIm_panel_digit_pos[i].Picture := nil;
end;





procedure TForm1.Vid_Show_Panel_Stage;
{ displays the number of the current stage                                     }
begin
  aIm_panel_digit_pos[1].Picture := aIm_panel_lives[1].Picture;                 // "-"
  aIm_panel_digit_pos[2].Picture := aIm_panel_lives[1].Picture;                 // "-"
  aIm_panel_digit_pos[3].Picture := nil;                                        // (space)
  aIm_panel_digit_pos[4].Picture := aIm_panel_number[iStage div 10].Picture;    // tens
  aIm_panel_digit_pos[5].Picture := aIm_panel_number[iStage mod 10].Picture;    // units
  aIm_panel_digit_pos[6].Picture := nil;                                        // (space)
  aIm_panel_digit_pos[7].Picture := aIm_panel_lives[1].Picture;                 // "-"
  aIm_panel_digit_pos[8].Picture := aIm_panel_lives[1].Picture;                 // "-"
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Snd_Play(pfs: PFSoundSample);
{ plays a certain sound sample                                                 }
begin
  if bSound then
    FSOUND_PlaySound(FSOUND_FREE, pfs);
end;





procedure TForm1.Snd_Silence;
{ stops any currently playing sound sample                                     }
begin
  if bSound then
    FSOUND_StopSound(FSOUND_ALL);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.im_backgroundMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: PRESS                                                }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (Button = mbLeft) then
    begin
      iMouseX := X;
      iMouseY := Y;
    end;
end;





procedure TForm1.im_backgroundMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: MOVE                                                 }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (ssLeft in Shift) then
    begin
      Top  := Top  + Y - iMouseY;
      Left := Left + X - iMouseX;
    end;
end;





procedure TForm1.btn_mode_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Mode switch: CLICK                                                           }
begin
  if Button = mbLeft then
    Inp_mode_down;
end;





procedure TForm1.btn_ama_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Ama button: PRESS                                                            }
begin
  if Button = mbLeft then
    Inp_ama_down;
end;





procedure TForm1.btn_ama_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Ama button: RELEASE                                                          }
begin
  if Button = mbLeft then
    Inp_ama_up;
end;





procedure TForm1.btn_pro_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Pro button: PRESS                                                            }
begin
  if Button = mbLeft then
    Inp_pro_down;
end;





procedure TForm1.btn_pro_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Pro button: RELEASE                                                          }
begin
  if Button = mbLeft then
    Inp_pro_up;
end;





procedure TForm1.btn_time_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Time button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_time_down;
end;





procedure TForm1.btn_time_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ Time button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_time_up;
end;





procedure TForm1.btn_up_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ UP button: PRESS                                                             }
begin
  if Button = mbLeft then
    Inp_up_down;
end;





procedure TForm1.btn_up_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ UP button: RELEASE                                                           }
begin
  if Button = mbLeft then
    Inp_up_up;
end;





procedure TForm1.btn_left_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ LEFT button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_left_down;
end;





procedure TForm1.btn_left_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ LEFT button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_left_up;
end;





procedure TForm1.btn_right_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ RIGHT button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_right_down;
end;





procedure TForm1.btn_right_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ RIGHT button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_right_up;
end;





procedure TForm1.btn_down_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ DOWN button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_down_down;
end;





procedure TForm1.btn_down_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ DOWN button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_down_up;
end;





procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: PRESS                                                              }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[1].word then Inp_ama_down   else                               // Ama
  if Key = aKeys[2].word then Inp_pro_down   else                               // Pro
  if Key = aKeys[3].word then Inp_time_down  else                               // Time
  if Key = aKeys[4].word then Inp_mode_down  else                               // Mode
  if Key = aKeys[5].word then Inp_up_down    else                               // Up
  if Key = aKeys[6].word then Inp_left_down  else                               // Left
  if Key = aKeys[7].word then Inp_right_down else                               // Right
  if Key = aKeys[8].word then Inp_down_down;                                    // Down
end;





procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: RELEASE                                                            }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[1].word then Inp_ama_up   else                                 // Ama
  if Key = aKeys[2].word then Inp_pro_up   else                                 // Pro
  if Key = aKeys[3].word then Inp_time_up  else                                 // Time
  if Key = aKeys[5].word then Inp_up_up    else                                 // Up
  if Key = aKeys[6].word then Inp_left_up  else                                 // Left
  if Key = aKeys[7].word then Inp_right_up else                                 // Right
  if Key = aKeys[8].word then Inp_down_up;                                      // Down
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Inp_mode_down;
{ Mode switch: CLICK                                                           }
begin
  if iMode = 1 then                                                             // time (switch)  ->
    begin                                                                          //                -> demo (switch)
      iMode := 2;                                                                  
      btn_mode_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int] + ' ' + HINT_MODE_GAME;
    end
  else                                                                          // whichever mode ->
    begin                                                                         //                -> time (switch)
      iMode := 1;
      btn_mode_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int] + ' ' + HINT_MODE_TIME;
    end;

  Gam_Set_Mode;
end;





procedure TForm1.Inp_ama_down;
{ Ama button: PRESS                                                            }
begin
  btn_ama_down.Visible := true;

  if (iMode = 2)                                                                // demo (switch)           ->
  or (iMode = 7)                                                                // time (with demo switch) ->
  or (iMode = 8) then                                                           // game over               ->
    begin
      iMode := 3;                                                               //                         -> Ama game setup

      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_ama_up;
{ Ama button: RELEASE                                                          }
begin
  btn_ama_down.Visible := false;

  if iMode = 3 then                                                             // Ama game setup ->
    begin
      iMode := 4;                                                               //                -> Ama game

      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_pro_down;
{ Pro button: PRESS                                                            }
begin
  btn_pro_down.Visible := true;

  if (iMode = 2)                                                                // demo (switch)           ->
  or (iMode = 7)                                                                // time (with demo switch) ->
  or (iMode = 8) then                                                           // game over               ->
    begin
      iMode := 5;                                                               //                         -> Pro game setup

      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_pro_up;
{ Pro button: RELEASE                                                          }
begin
  btn_pro_down.Visible := false;

  if iMode = 5 then                                                             // Pro game setup ->
    begin
      iMode := 6;                                                               //                -> Pro game

      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_time_down;
{ Time button: PRESS                                                           }
begin
  btn_time_down.Visible := true;

  if (iMode = 2)                                                                // demo (switch) ->
  or (iMode = 8) then                                                           // game over     ->
    begin
      iMode := 7;                                                               //               -> time (with demo switch)

      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_time_up;
{ Time button: RELEASE                                                         }
begin
  btn_time_down.Visible := false;
end;





procedure TForm1.Inp_down_down;
{ DOWN button: PRESS                                                           }
begin
  btn_down_down.Visible := true;

  bDownPressed := true;
end;





procedure TForm1.Inp_down_up;
{ DOWN button: RELEASE                                                         }
begin
  btn_down_down.Visible  := false;

  bDownPressed := false;
end;





procedure TForm1.Inp_left_down;
{ LEFT button: PRESS                                                           }
begin
  btn_left_down.Visible := true;

  bLeftPressed := true;
end;





procedure TForm1.Inp_left_up;
{ LEFT button: RELEASE                                                         }
begin
  btn_left_down.Visible  := false;

  bLeftPressed := false;
end;





procedure TForm1.Inp_right_down;
{ RIGHT button: PRESS                                                          }
begin
  btn_right_down.Visible := true;

  bRightPressed := true;
end;





procedure TForm1.Inp_right_up;
{ RIGHT button: RELEASE                                                        }
begin
  btn_right_down.Visible := false;
  
  bRightPressed := false;
end;





procedure TForm1.Inp_up_down;
{ UP button: PRESS                                                             }
begin
  btn_up_down. Visible := true;

  bUpPressed := true;
end;





procedure TForm1.Inp_up_up;
{ UP button: RELEASE                                                           }
begin
  btn_up_down.Visible := false;

  bUpPressed := false;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME                                                         * }
{ *                                                                          * }
{ **************************************************************************** }

procedure Tform1.Gam_Stop_All_Timers;
{ stops action                                                                 }
begin
  Timer_Cherry_Bonus.Enabled     := false;
  Timer_Clock.Enabled            := false;
  Timer_Game.Enabled             := false;
  Timer_Game_Start.Enabled       := false;
  Timer_Ghost_Bonus.Enabled      := false;
  Timer_Intermission.Enabled     := false;
  Timer_Miss.Enabled             := false;
  Timer_Power_Pill_Sound.Enabled := false;
  Timer_Stage_Complete.Enabled   := false;
end;





procedure TForm1.Gam_Add_Bonus_Life;
{ adds a life if the current life counter is below 3, then sets the new score  }
{ value to get a bonus life                                                    }
begin
  if iLives < 3 then
    Inc(iLives);

  Inc(iScoreBonusLife, 20000);
end;





procedure TForm1.Gam_Calculate_Cherry_Value;
{ sets value of the iScoreCherry variable, depending on current stage number   }
begin
  case iStage of
    1, 2: iScoreCherry := 200;                                                  // levels 1 and 2
    3, 4: iScoreCherry := 400;                                                  // levels 3 and 4
    5, 6: iScoreCherry := 600;                                                  // levels 5 and 6
    7, 8: iScoreCherry := 800;                                                  // levels 7 and 8
    9:    iScoreCherry := 1000;                                                 // level 9 only
    else  iScoreCherry := 2000;                                                 // level 10 and above
  end; // case..of
end;





procedure TForm1.Gam_Game_Over;
{ game ends. checks for the new high score and then sets iMode to "game over"  }
begin
  while iScore >= 1000000 do
    Dec(iScore, 1000000);

  // displays "A" or "P"
  case iMode of
    4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;
    6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;
  end; // case..of

  Vid_Show_Panel_Lives(iLives);
  Vid_Show_Panel_Score(iScore, true);

  if (iMode = 4) and (iScore > iHiScoreA) then begin iHiScoreA := iScore; iReg.WriteInteger('', 'HiScore1', iHiScoreA); end;
  if (iMode = 6) and (iScore > iHiScoreP) then begin iHiScoreP := iScore; iReg.WriteInteger('', 'HiScore2', iHiScoreP); end;

  im_panel_over.Visible := true;

  iMode := 8; Gam_Set_Mode;
end;





procedure TForm1.Gam_Ghosts_Move;
{ ghosts move inside of the maze, in a pseudo-intelligent way                  }
var
  i,
  rnd:    integer;
  bCheck: boolean;
begin
  // pseudo-AI movement
  for i := 1 to 3 do
    if rGhost[i].iStatus > 3 then
      repeat
        bCheck := false;

        rnd := Random(4) + 1;                                                   // random direction

        if rGhost[i].y = iPacmanY then                                          // if ghost is in horizontal line with Pac Man
          begin                                                                   // AI
            if (rGhost[i].x > iPacmanX)                                             // ghost is on the right of Pac Man
              and aMaze[rGhost[i].y, rGhost[i].x].l then                            // and left cell is available
              if rGhost[i].iStatus = 4 then                                         // in chase mode
                rnd := 1                                                              // ghost chases (LEFT)
              else                                                                  // else
                repeat rnd := Random(4) + 1 until rnd <> 1;                           // ghost flees (RND OTHER THAN LEFT)

            if (rGhost[i].x < iPacmanX)                                             // ghost is on the left of Pac Man
              and aMaze[rGhost[i].y, rGhost[i].x].r then                            // and right cell is available
              if rGhost[i].iStatus = 4 then                                         // in chase mode
                rnd := 2                                                              // ghost chases (RIGHT)
              else                                                                  // else
                repeat rnd := Random(4) + 1 until rnd <> 2;                           // ghost flees (RND OTHER THAN RIGHT)

            if (rGhost[i].y = 2) or (rGhost[i].y = 4) then                          // ghost in front of a tunnel
              begin
                if(rGhost[i].x = 1) and (iPacmanX = 8) then                           // ghost on col. 1, Pac Man on col. 8
                  if rGhost[i].iStatus = 4 then                                         // in chase mode
                    rnd := 1                                                              // ghost chases (RIGHT)
                  else                                                                  // else
                    repeat rnd := Random(4) + 1 until rnd <> 1;                           // ghost flees (RND OTHER THAN RIGHT)

                if(rGhost[i].x = 8) and (iPacmanX = 1) then                         // ghost on col. 8, Pac Man on col. 1
                  if rGhost[i].iStatus = 4 then                                       // in chase mode
                    rnd := 2                                                            // ghost chases (RIGHT)
                  else                                                                // else
                    repeat rnd := Random(4) + 1 until rnd <> 2;                         // ghost flees (RND OTHER THAN RIGHT)
              end; // if (rGhost[i].y = 2) or (rGhost[i].y = 4) then
           end; // if rGhost[i].y = iPacmanY then

        case rnd of
          1: if aMaze[rGhost[i].y, rGhost[i].x].l then                          // LEFT
               begin
                 Vid_Show_Ghost(i, false);
                 Dec(rGhost[i].x);
                 if rGhost[i].x < 1 then rGhost[i].x := 8;
                 Vid_Show_Ghost(i, true);
                 bCheck := true;
               end;
          2: if aMaze[rGhost[i].y, rGhost[i].x].r then                          // RIGHT
               begin
                 Vid_Show_Ghost(i, false);
                 Inc(rGhost[i].x);
                 if rGhost[i].x > 8 then rGhost[i].x := 1;
                 Vid_Show_Ghost(i, true);
                 bCheck := true;
               end;
          3: if aMaze[rGhost[i].y, rGhost[i].x].u then                          // UP
               begin
                 Vid_Show_Ghost(i, false);
                 Dec(rGhost[i].y);
                 Vid_Show_Ghost(i, true);
                 bCheck := true;
               end;
          4: if aMaze[rGhost[i].y, rGhost[i].x].d then                          // DOWN
               begin
                 aIm_ghost[rGhost[i].y, rGhost[i].x].Visible := false;
                 Inc(rGhost[i].y);
                 Vid_Show_Ghost(i, true);
                 bCheck := true;
               end;
        end; // case of
      until
        bCheck;
end;





procedure TForm1.Gam_Ghosts_Pit_Move;
{ ghosts move inside of the pit, getting out of it step by step                }
  var
    i: integer;
    a: array[1..3] of integer;
begin
  // fills pit-array (pass 1)
  for i := 1 to 3 do
    a[i] := 0;

  for i := 1 to 3 do
    if (rGhost[i].iStatus >= 1) and (rGhost[i].iStatus <= 3) then
      a[rGhost[i].iStatus] := i;

  // updates the status of each ghost in the pit
  if a[3] <> 0 then
    begin
      rGhost[a[3]].iStatus := 4;
      rGhost[a[3]].x := 3;
      rGhost[a[3]].y := 3;

      Vid_Show_Ghost(a[3], true);
    end
  else
    if (a[3] = 0) and (a[2] <> 0) then
      Inc(rGhost[a[2]].iStatus)
    else
      if (a[2] = 0) and (a[1] <> 0) then
        Inc(rGhost[a[1]].iStatus);

  // updates pit-array (pass 2)
  for i := 1 to 3 do
    a[i] := 0;

  for i := 1 to 3 do
    if (rGhost[i].iStatus >= 1) and (rGhost[i].iStatus <= 3) then
      a[rGhost[i].iStatus] := i;

  for i := 1 to 3 do
    aIm_ghost_pit[i].Visible := (a[i] >= 1) and (a[i] <= 3);
end;





procedure TForm1.Gam_Pacman_Eats;
{ Pac Man eats a pill (single/double/power pill)                               }
  var
    i, j: integer;
begin
  // assigns the value of current pill to "i"
  i := aPill[iPacmanY, iPacmanX];

  // pill is eaten
  aPill[iPacmanY, iPacmanX] := 0;
  aIm_pill[iPacmanY, iPacmanX].Visible := false;

  // increases score by "i" (5, 10 or 100)
  Inc(iScore, i);
  Vid_Show_Panel_Score(iScore, true);

  // game over check
  if iScore > 999999 then
    begin
      Gam_Stop_All_Timers;
      Snd_Silence;

      iLives := 1;                                                              // becomes 0 with the next Timer_Miss tick

      iLoopMiss := 1;
      Timer_Miss.Interval := 1;
      Timer_Miss.Enabled := true;
    end
  else
    begin
      // gives a bonus life at 5,000 and at every 20,000 points
      if iScore >= iScoreBonusLife then
        begin
          Gam_Add_Bonus_Life;

          j := iLives - 1;
          Vid_Show_Panel_Lives(j);
        end;

      // updates number of remaining pills (to complete stage and to display a new cherry)
      Dec(iPillsLeftForStage, i);

      case i of
        5, 100: Dec(iPillsLeftForCherry, 1);
        10: Dec(iPillsLeftForCherry, 2);
      end; // case..of

      // if it was a "power pill"
      if (i = 100)
      and (iPillsLeftForStage > 0) then
        begin
          // enables the "power pill" mode
          iScoreGhost := 200;

          iLoopGamePowerPill := 1;

          for i := 1 to 3 do
            if rGhost[i].iStatus = 4 then
              rGhost[i].iStatus := 5;

          // starts timer to let the "beep-beep" play
          Timer_Power_Pill_Sound.Interval := 180;
          Timer_Power_Pill_Sound.Enabled := true;
        end; // if (i = 100) and (iPillsLeftForStage > 0) then
    end; // if iScore > 999999 then
end;





procedure TForm1.Gam_Set_Mode;
{ sets handheld in time/game modes, depending on the value of the iMode        }
{ variable                                                                     }
  var
    i: integer;
begin
  case iMode of
    1: begin                                                                    // time (switch)
         btn_mode_time.Visible := true;

         Gam_Stop_All_Timers;
         Snd_Silence;

         bControls := false;

         Vid_Show_All(false);

         Timer_Clock.Interval := 1;
         Timer_Clock.Enabled := true;
       end;
    2: begin                                                                    // demo (switch)
         btn_mode_time.Visible := false;

         Timer_Clock.Enabled := false;

         im_panel_time_pm.Visible := false;
         i := 0; Vid_Show_Panel_Score_Bonus(i, true);                             // displays seven blank spaces and "0"
       end;
    3: begin                                                                    // Ama game setup
         Timer_Clock.Enabled := false;

         Vid_Show_All(false);                                                     // clears the display
         aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;          // "A"
         aIm_panel_digit_pos[2].Picture := nil;                                   // (space)
         Vid_Show_Panel_Score(iHiScoreA, true);                                   // high score for "Ama" game

         Gam_Set_New_Maze_Pills;
         Gam_Set_New_Maze_Ghosts;
       end;
    5: begin                                                                    // Pro game setup
         Timer_Clock.Enabled := false;

         Vid_Show_All(false);                                                     // clears the display
         aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;          // "P"
         aIm_panel_digit_pos[2].Picture := nil;                                   // (space)
         Vid_Show_Panel_Score(iHiScoreP, true);                                   // high score for "Pro" game

         Gam_Set_New_Maze_Pills;
         Gam_Set_New_Maze_Ghosts;
       end;
    4, 6: begin                                                                 // Ama and Pro game
         iLives := 3;
         iScore := 0;
         iScoreBonusLife := 5000;
         iStage := 1;

         Gam_Calculate_Cherry_Value;

         iLoopGameStart := 1;
         Timer_Game_Start.Interval := 1;
         Timer_Game_Start.Enabled := true;
       end;
    7: begin                                                                    // time (with demo switch)
         Vid_Show_All(false);

         Timer_Clock.Interval := 1;
         Timer_Clock.Enabled := true;
       end;
    8: begin                                                                    // game over
         // does nothing
       end;
  end; // case..of
end;





procedure TForm1.Gam_Set_New_Maze_Ghosts;
{ prepares the ghosts on a new stage                                           }
  var
    i: integer;
begin
  rGhost[1].iStatus := 1;
  rGhost[2].iStatus := 2;
  rGhost[3].iStatus := 3 * Ord( (iMode = 5) or (iMode = 6) );                   // Ama mode: 2 ghosts; Pro mode: 3 ghosts

  // displays 2 or 3 ghosts in their pit
  for i := 1 to 3 do
    aIm_ghost_pit[i].Visible := (rGhost[i].iStatus >= 1) and (rGhost[i].iStatus <= 3)
end;





procedure TForm1.Gam_Set_New_Maze_Pills;
{ prepares the pills on a new stage                                            }
  var
    i, j: integer;
begin
  for i := 1 to 5 do                                                            // fills maze with pills
    for j := 1 to 8 do
      aPill[i, j] := 0;

  aPill[1, 1] := 10;                                                                                            aPill[1, 7] := 100;
                      aPill[2, 2] := 5;                   aPill[2, 4] := 5;                   aPill[2, 6] := 5;                     aPill[2, 8] := 5;
  aPill[3, 1] := 10;                                                                                            aPill[3, 7] := 10;
                      aPill[4, 2] := 5;                   aPill[4, 4] := 5;                   aPill[4, 6] := 5;                     aPill[4, 8] := 5;
  aPill[5, 1] := 100;                   aPill[5, 3] := 5;                   aPill[5, 5] := 5;                   aPill[5, 7] := 10;

  Vid_Show_All_Pills(true);                                                     // displays all pills

  iPillsLeftForStage := 290;                                                    // sets value of pills to eat to get next stage
  iPillsLeftForCherry := 8;                                                     // sets number of pills to eat to get a cherry
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: TIMERS                                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Timer_Cherry_BonusTimer(Sender: TObject);
{ "bonus" tune is played, then game continues                                  }
  var
    i: integer;
begin
  case iLoopCherryBonus of
    1: begin                                                                    // hides maze + removes cherry + plays sound sample
         Vid_Show_Panel_Score_Bonus(iScoreCherry, true);

         im_cherry.Visible := false;

         Snd_Play(pfs_bonus);

         Timer_Cherry_Bonus.Interval := 1200;
       end;
    2: begin                                                                    // displays maze + pacman + cherry score
         // displays "A" or "P"
         case iMode of
           4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;
           6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;
         end; // case..of

         i := iLives - 1; Vid_Show_Panel_Lives(i);                                // in-game lives counter
         Vid_Show_Panel_Score(iScore, true);

         iLoopGameCherry := 0;
         Timer_Game.Interval := 100;
         Timer_Game.Enabled := true;

         if iLoopGamePowerPill <> 0 then
           begin
             Timer_Power_Pill_Sound.Interval := 180;
             Timer_Power_Pill_Sound.Enabled := true;
           end;

         bControls := true;

         Timer_Cherry_Bonus.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopCherryBonus);
end;





procedure TForm1.Timer_ClockTimer(Sender: TObject);
{ transforms current time into "sprites" form, then displays it                }
  var
    present:              TDateTime;
    hour, min, sec, msec: Word;
begin
  present := Now;                                                               // gets system time...
  DecodeTime(present, hour, min, sec, msec);                                    // and decodes it

  if hour > 11 then                                                             // changes mode from 0/24 to 12 AM/12 PM
    begin
      Dec(hour, 12);
      im_panel_time_pm.Visible := true;
    end
  else
    im_panel_time_pm.Visible := false;

  if hour = 0 then                                                              // changes mode from 0/24 to 12 AM/12 PM
    hour := 12;

  if hour > 9 then                                                                // hour: tens
    aIm_panel_digit_pos[1].Picture := aIm_panel_number[hour div 10 mod 10].Picture
  else
    aIm_panel_digit_pos[1].Picture := nil;

  aIm_panel_digit_pos[2].Picture := aIm_panel_number[hour mod 10].Picture;        // hour: units
  aIm_panel_digit_pos[3].Picture := aIm_panel_lives[1].Picture;                   // "-"
  aIm_panel_digit_pos[4].Picture := aIm_panel_number[min  div 10].Picture;        // minute: tens
  aIm_panel_digit_pos[5].Picture := aIm_panel_number[min  mod 10].Picture;        // minute: units
  aIm_panel_digit_pos[6].Picture := nil;                                          // (space)
  aIm_panel_digit_pos[7].Picture := aIm_panel_number[sec  div 10].Picture;        // second: tens
  aIm_panel_digit_pos[8].Picture := aIm_panel_number[sec  mod 10].Picture;        // second: units

  Timer_Clock.Interval := 1000;
end;





procedure TForm1.Timer_GameTimer(Sender: TObject);
{ main game action                                                             }
  var
    i:       integer;
    bStage,
    bMiss,
    bGhost,
    bCherry,
    bOver:   boolean;
    pf:      PFSoundSample;
begin
  bStage  := false;
  bMiss   := false;
  bGhost  := false;
  bCherry := false;
  bOver   := false;

  pf := nil;

  {                                                                            }
  { GHOSTS IN MAZE MOVE                                                        }
  {                                                                            }

  if iLoopGameGhost = 7 then
    begin
      Gam_Ghosts_Move;

      // sets which sound sample to play
      if iLoopGamePowerPill = 0 then
        pf := pfs_beep;
    end;

  // loops action (7 ticks)
  Inc(iLoopGameGhost);

  if iLoopGameGhost = 8 then
    iLoopGameGhost := 1;

  {                                                                            }
  { COLLISION CHECK (1)                                                        }
  {                                                                            }

  for i := 1 to 3 do
    if (rGhost[i].iStatus = 4)
      and (rGhost[i].x = iPacmanX)
      and (rGhost[i].y = iPacmanY) then
      bMiss := true;

  for i := 1 to 3 do
    if (rGhost[i].iStatus = 5)
      and (rGhost[i].x = iPacmanX)
      and (rGhost[i].y = iPacmanY) then
      bGhost := true;

  {                                                                            }
  { GHOSTS IN THE PIT MOVE OUT OF IT                                           }
  {                                                                            }

  if not bMiss then
    begin
      if (iLoopGameGhostPit = 8)                                                // tick is 1 after iLoopGameGhost, which occurs at every 7 ticks
        and (iLoopGamePowerPill = 0) then
          Gam_Ghosts_Pit_Move;

      // loops action (14 ticks)
      Inc(iLoopGameGhostPit);

      if iLoopGameGhostPit = 15 then
        iLoopGameGhostPit := 1;
    end; // if not bMiss then

  {                                                                            }
  { PAC MAN MOVES                                                              }
  {                                                                            }

  if (not bMiss)
    and (not bGhost) then
    begin
      if iLoopGamePacman = 6 then
        begin
          if bLeftPressed                                                       // LEFT -> MOVE
            and bControls
            and aMaze[iPacmanY, iPacmanX].l then
            begin
              // moves Pac Man to a new cell
              Vid_Show_Pacman(false);
              Dec(iPacmanX);
              if iPacmanX < 1 then iPacmanX := 8;
              Vid_Show_Pacman(true);

              // checks whether there's a pill there
              if aPill[iPacmanY, iPacmanX] <> 0 then
                begin                                                             // -> EAT
                  // Pac Man eats a pill
                  Gam_Pacman_Eats;

                  // sets sound sample to play
                  pf := pfs_point;
                end; // -> EAT * END*
            end // LEFT -> MOVE * END *
          else
            if bLeftPressed                                                     // LEFT -> CHERRY
              and bControls
              and (iPacmanY = 3)
              and (iPacmanX = 6)
              and im_cherry.Visible then
                bCherry := true // LEFT -> CHERRY * END *
            else
              if bRightPressed                                                  // RIGHT -> MOVE
                and bControls
                and aMaze[iPacmanY, iPacmanX].r then
                begin
                  Vid_Show_Pacman(false);
                  Inc(iPacmanX);
                  if iPacmanX > 8 then iPacmanX := 1;
                  Vid_Show_Pacman(true);
                end // RIGHT -> MOVE * END *
              else
                if bUpPressed                                                   // UP -> MOVE
                  and bControls
                  and aMaze[iPacmanY, iPacmanX].u then
                  begin
                    Vid_Show_Pacman(false);
                    Dec(iPacmanY);
                    Vid_Show_Pacman(true);
                  end
                else // UP -> MOVE * END *
                  if bDownPressed                                               // DOWN -> MOVE
                    and bControls
                    and aMaze[iPacmanY, iPacmanX].d then
                    begin
                      Vid_Show_Pacman(false);
                      Inc(iPacmanY);
                      Vid_Show_Pacman(true);
                    end; // DOWN -> MOVE * END *
        end; // if iLoopGamePacman = 6

      // loops action (6 ticks)
      Inc(iLoopGamePacman);

      if iLoopGamePacman = 7 then
        iLoopGamePacman := 1;
    end; // if not bMiss then

  {                                                                            }
  { STAGE COMPLETE CHECK!                                                      }
  {                                                                            }

  if iPillsLeftForStage = 0 then
    begin
      bStage := true;

      Gam_Stop_All_Timers;
      Snd_Silence;

      bControls := false;

      // new stage settings
      Inc(iStage);

      if iStage = 100 then
        iStage := 1;

      Gam_Calculate_Cherry_Value;

      // starts a new stage or goes into "intermission" at level 6 and at every 5 levels
      if iStage mod 5 = 1 then
        begin
          iLoopIntermission := 1;
          Timer_Intermission.Interval := 1;
          Timer_Intermission.Enabled := true;
        end
      else
        begin
          iLoopStageComplete := 1;
          Timer_Stage_Complete.Interval := 1;
          Timer_Stage_Complete.Enabled := true;
        end;
    end;

  {                                                                            }
  { COLLISION CHECK! (2)                                                       }
  {                                                                            }

  for i := 1 to 3 do
    if (rGhost[i].iStatus = 4)
      and (rGhost[i].x = iPacmanX)
      and (rGhost[i].y = iPacmanY) then
      bMiss := true;

  for i := 1 to 3 do
    if (rGhost[i].iStatus = 5)
      and (rGhost[i].x = iPacmanX)
      and (rGhost[i].y = iPacmanY) then
      bGhost := true;

  {                                                                            }
  { MISS CHECK!                                                                }
  {                                                                            }

  if (not bStage)
    and bMiss then
    begin
      // stops action
      Gam_Stop_All_Timers;
      Snd_Silence;

      bControls := false;

      iLoopMiss := 1;
      Timer_Miss.Interval := 1;
      Timer_Miss.Enabled := true;
    end;

  {                                                                            }
  { GHOST WAS EATEN CHECK!                                                     }
  {                                                                            }

  if (not bStage)
    and (not bMiss)
    and (not bCherry)
    and bGhost then
    begin
      Gam_Stop_All_Timers;
      Snd_Silence;

      bControls := false;

      Inc(iScore, iScoreGhost);

      // game over check
      if iScore > 999999 then
        bOver := true
      else
        begin
          // gives a bonus life at 5,000 and at every 20,000 points
          if iScore >= iScoreBonusLife then
            Gam_Add_Bonus_Life;

          iLoopGhostBonus := 1;
          Timer_Ghost_Bonus.Interval := 1;
          Timer_Ghost_Bonus.Enabled := true;
        end; // if iScore > 999999 else
    end;

  {                                                                            }
  { CHERRY WAS EATEN CHECK!                                                    }
  {                                                                            }

  if (not bStage)
    and (not bMiss)
    and (not bGhost)
    and (not bOver)
    and bCherry then
    begin
      Gam_Stop_All_Timers;
      Snd_Silence;

      bControls := false;

      Inc(iScore, iScoreCherry);

      // game over check
      if iScore > 999999 then
        bOver := true
      else
        begin
          // gives a bonus life at 5,000 and at every 20,000 points
          if iScore >= iScoreBonusLife then
            Gam_Add_Bonus_Life;

          iLoopCherryBonus := 1;
          Timer_Cherry_Bonus.Interval := 1;
          Timer_Cherry_Bonus.Enabled := true;
        end; // if iScore > 999999 else
    end;

  {                                                                            }
  { ON SCREEN/HIDDEN CHERRY LOOP (OPTIONAL)                                    }
  {                                                                            }

  if (not bStage)
    and (not bMiss)
    and (not bGhost)
    and (not bCherry)
    and (not bOver)
    and (iPillsLeftForCherry <= 0) then
    begin
      // restores the number of pills to eat in order to get a new cherry (8 or 9)
      Inc(iPillsLeftForCherry, 8);

      // a new cherry appears (timer stop + timer start)
      iLoopGameCherry := 1;
    end;

  im_cherry.Visible := iLoopGameCherry <> 0;

  // loops action (lasts 75 ticks or until the cherry is eaten)
  if iLoopGameCherry <> 0 then
    Inc(iLoopGameCherry);

  if iLoopGameCherry = 75 then
    iLoopGameCherry := 0;

  {                                                                            }
  { POWER PILL LOOP (OPTIONAL)                                                 }
  {                                                                            }

  if iLoopGamePowerPill = 58 then
    begin
      for i := 1 to 3 do
        if rGhost[i].iStatus = 5 then
          begin
            rGhost[i].iStatus := 4;
            Vid_Show_Ghost(i, true);
          end;

      iLoopGamePowerPill := 0;
    end;

  // loops action (lasts 58 ticks)
  if iLoopGamePowerPill <> 0 then
    Inc(iLoopGamePowerPill);

  {                                                                            }
  { SOUNDS                                                                     }
  {                                                                            }

  if (pf <> nil)
  and (not bOver) then
    Snd_Play(pf);

  {                                                                            }
  { GAME OVER                                                                  }
  {                                                                            }

  if bOver then
    begin
      Vid_Show_Panel_Score(iScore, true);
      Gam_Stop_All_Timers;
      Snd_Silence;

      iLives := 1;                                                              // becomes 0 with the next Timer_Miss tick

      iLoopMiss := 1;
      Timer_Miss.Interval := 1;
      Timer_Miss.Enabled := true;
    end;
end;





procedure TForm1.Timer_Game_StartTimer(Sender: TObject);
{ displays info panel (lives, stage), plays fanfare and then game begins       }
  var
    i: integer;
begin
  case iLoopGameStart of
    1: begin
         Snd_Play(pfs_start);

         Timer_Game_Start.Interval := 3500;
       end;
    2: begin
         Vid_Show_Panel_Stage;

         Timer_Game_Start.Interval := 2000;
       end;
    3: begin
         case iMode of
           4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;   // "A"
           6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;   // "P"
         end; // case..of

         Vid_Show_Panel_Lives(iLives);
         Vid_Show_Panel_Score(iScore, true);
       end;
    4: begin
         i := iLives - 1; Vid_Show_Panel_Lives(i);

         iPacmanX := 8; iPacmanY := 5; Vid_Show_Pacman(true);

         iLoopGamePacman := 1;                                                  // active, loops 1-6  (action occurs when value is 6)
         iLoopGameGhost := 1;                                                   // active, loops 1-7  (action occurs when value is 7)
         iLoopGameGhostPit := 1;                                                // active, loops 1-14 (action occurs when value is 4)
         iLoopGamePowerPill := 0;                                               // not active
         iLoopGameCherry := 0;                                                  // not active
         Timer_Game.Interval := 100;
         Timer_Game.Enabled := true;

         bControls := true;

         Timer_Game_Start.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopGameStart);
end;





procedure TForm1.Timer_Ghost_BonusTimer(Sender: TObject);
{ pacman and score blink, then game continues                                  }
  var
    i: integer;
begin
  case iLoopGhostBonus of
    1: begin
         Vid_Show_Panel_Score_Bonus(iScoreGhost, true);

         Snd_Play(pfs_bonus);

         Timer_Ghost_Bonus.Interval := 1200;
       end;
    2: begin
         // updates status of eaten ghost
         i := 1;

         if (rGhost[1].iStatus = 5) and (rGhost[1].x = iPacmanX) and (rGhost[1].y = iPacmanY) then i := 1 else
         if (rGhost[2].iStatus = 5) and (rGhost[2].x = iPacmanX) and (rGhost[2].y = iPacmanY) then i := 2 else
         if (rGhost[3].iStatus = 5) and (rGhost[3].x = iPacmanX) and (rGhost[3].y = iPacmanY) then i := 3;

         if not aIm_ghost_pit[1].Visible then rGhost[i].iStatus := 1 else
         if not aIm_ghost_pit[2].Visible then rGhost[i].iStatus := 2 else
         if not aIm_ghost_pit[3].Visible then rGhost[i].iStatus := 3;

         // hides eaten ghosts
         Vid_Show_Ghost(i, false);

         for i := 1 to 3 do
           case rGhost[i].iStatus of
             1, 2, 3: Vid_Show_Ghost_Pit(rGhost[i].iStatus, true);
             4, 5: Vid_Show_Ghost(i, true);
           end; // case..of
           
         iScoreGhost := iScoreGhost * 2;

         // displays "A" or "P"
         case iMode of
           4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;
           6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;
         end; // case..of

         i := iLives - 1; Vid_Show_Panel_Lives(i);                              // in-game lives counter
         Vid_Show_Panel_Score(iScore, true);

         // game continues
         Timer_Game.Interval := 100;
         Timer_Game.Enabled := true;

         if iLoopGamePowerPill <> 0 then
           begin
             Timer_Power_Pill_Sound.Interval := 180;
             Timer_Power_Pill_Sound.Enabled := true;
           end;

         bControls := true;

         Timer_Ghost_Bonus.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopGhostBonus);
end;





procedure TForm1.Timer_IntermissionTimer(Sender: TObject);
{ clears maze, displays blinking "good", then game reprises with a new maze    }
  var
    i: integer;
begin
  case iLoopIntermission of
    1: Timer_Intermission.Interval := 600;
    2, 4, 6: begin
         aIm_panel_digit_pos[1].Picture := nil;                                 // (space)
         aIm_panel_digit_pos[2].Picture := nil;                                 // (space)
         aIm_panel_digit_pos[3].Picture := aIm_panel_number[9].Picture;         // "g"
         aIm_panel_digit_pos[4].Picture := aIm_panel_number[12].Picture;        // "o"
         aIm_panel_digit_pos[5].Picture := aIm_panel_number[12].Picture;        // "o"
         aIm_panel_digit_pos[6].Picture := aIm_panel_number[11].Picture;        // "d"
         aIm_panel_digit_pos[7].Picture := nil;                                 // (space)
         aIm_panel_digit_pos[8].Picture := nil;                                 // (space)
       end;
    3, 5, 7: for i := 1 to 8 do
         aIm_panel_digit_pos[i].Picture := nil;
    8: begin
         i := 200; Vid_Show_Panel_Score_Bonus(i, true);                         // 200
       end;
    9: begin
         i := 400; Vid_Show_Panel_Score_Bonus(i, true);                         // 400
       end;
   10: begin
         i := 600; Vid_Show_Panel_Score_Bonus(i, true);                         // 600
       end;
   11: begin
         i := 800; Vid_Show_Panel_Score_Bonus(i, true);                         // 800
       end;
   12: begin
         i := 1000; Vid_Show_Panel_Score_Bonus(i, true);                        // 1000

         Inc(iScore, 1000);

         // game over check
         if iScore >= 1000000 then
           begin
             Gam_Stop_All_Timers;
             Snd_Silence;

             iLives := 1;                                                       // becomes 0 with the next Timer_Miss tick

             iLoopMiss := 1;
             Timer_Miss.Interval := 1;
             Timer_Miss.Enabled := true;
           end
         else
           begin
             if iScore >= iScoreBonusLife then
               Gam_Add_Bonus_Life;

             iLoopStageComplete := 1;
             Timer_Stage_Complete.Interval := 1;
             Timer_Stage_Complete.Enabled := true;
           end;

         Timer_Intermission.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopIntermission);
end;





procedure TForm1.Timer_MissTimer(Sender: TObject);
{ subtracts one life, then game is over or continues                           }
  var
    i: integer;
begin
  case iLoopMiss of
    1: begin
         Snd_Play(pfs_miss);

         Timer_Miss.Interval := 2000;
       end;
    2: begin                                                                    // hides maze + removes cherry + plays sound sample
         Vid_Show_All_Ghosts(false);
         Vid_Show_All_Ghosts_Pit(false);
         Vid_Show_All_Pacman(false);
         im_cherry.Visible := false;

         Dec(iLives);

         if iLives = 0 then                                                     // game over check
           begin                                                                  // game over
             Gam_Game_Over;

             Timer_Miss.Enabled := false;
           end
         else
           Timer_Miss.Interval := 1500;                                           // game not over, continues
       end;
    3: begin                                                                    // just in case game is not over yet
         Vid_Show_Panel_Stage;

         Gam_Set_New_Maze_Ghosts;

         Timer_Miss.Interval := 2000;
       end;
    4: begin
         case iMode of
           4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;   // "A"
           6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;   // "P"
         end; // case..of

         Vid_Show_Panel_Lives(iLives);
         Vid_Show_Panel_Score(iScore, true);
       end;
    5: begin
         i := iLives - 1; Vid_Show_Panel_Lives(i);

         iPacmanX := 8; iPacmanY := 5; Vid_Show_Pacman(true);

         iLoopGamePacman := 1;                                                  // active, loops 1-6  (action occurs when value is 6)
         iLoopGameGhost := 1;                                                   // active, loops 1-7  (action occurs when value is 7)
         iLoopGameGhostPit := 1;                                                // active, loops 1-14 (action occurs when value is 4)
         iLoopGamePowerPill := 0;                                               // not active
         iLoopGameCherry := 0;                                                  // not active
         Timer_Game.Interval := 100;
         Timer_Game.Enabled := true;

         bControls := true;

         Timer_Miss.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopMiss);
end;





procedure TForm1.Timer_Power_Pill_SoundTimer(Sender: TObject);
{ plays "beep" sound repeatedly until power pill ends its effect               }
begin
  if iLoopGamePowerPill <> 0 then
    Snd_Play(pfs_beep)
  else
    Timer_Power_Pill_Sound.Enabled := false;
end;





procedure TForm1.Timer_Stage_CompleteTimer(Sender: TObject);
{ clears maze, then game continues on a new maze                               }
  var
    i: integer;
begin
  case iLoopStageComplete of
    1: Timer_Stage_Complete.Interval := 500;
    2: begin                                                                    // clears maze
         Vid_Show_Pacman(false);
         Vid_Show_All_Ghosts(false);
         Vid_Show_All_Ghosts_Pit(false);
         im_cherry.Visible := false;

         Timer_Stage_Complete.Interval := 1500;
       end;
    3: begin
         Vid_Show_Panel_Stage;

         Gam_Set_New_Maze_Pills;
         Gam_Set_New_Maze_Ghosts;
       end;
    4: begin
         case iMode of
           4: aIm_panel_digit_pos[1].Picture := aIm_panel_number[10].Picture;   // "A"
           6: aIm_panel_digit_pos[1].Picture := aIm_panel_number[13].Picture;   // "P"
         end; // case..of

         Vid_Show_Panel_Lives(iLives);
         Vid_Show_Panel_Score(iScore, true);
       end;
    5: begin
         i := iLives - 1; Vid_Show_Panel_Lives(i);

         iPacmanX := 8; iPacmanY := 5; Vid_Show_Pacman(true);

         iLoopGamePacman := 1;    // active, loops 1-6  (action occurs when value is 6)
         iLoopGameGhost := 1;     // active, loops 1-7  (action occurs when value is 7)
         iLoopGameGhostPit := 1;  // active, loops 1-14 (action occurs when value is 4)
         iLoopGamePowerPill := 0; // not active
         iLoopGameCherry := 0;    // not active
         Timer_Game.Interval := 100;
         Timer_Game.Enabled := true;

         bControls := true;

         Timer_Stage_Complete.Enabled := false;
       end;
  end; // case..of

  // loops action
  Inc(iLoopStageComplete);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.pm_0_menuPopup(Sender: TObject);
{ shows the "checked" menuitems if needed. also, hides the game menu if it is  }
{ visible when the popup menu pops up                                          }
begin
{}pm_11_splashscreen.Checked := iReg.ReadBool('', 'SplashScreen', SplashForm.chb_splashscreen.Checked);

{}if bFullscreenMode
    and bGameMenuOpen then
    begin
      bGameMenuOpen := false;
      Form1.Vid_Display_Game_Menu(bGameMenuOpen);
    end;
end;





procedure TForm1.pm_1_aboutClick(Sender: TObject);
{ displays the embedded "About the author..." form                             }
begin
  AboutForm.Show;
end;





procedure TForm1.pm_2_readmeClick(Sender: TObject);
{ opens the "Readme.txt" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Readme.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_3_whatsnewClick(Sender: TObject);
{ opens the "Whatsnew.txt" file                                                }
begin
  ShellExecute(Handle, 'open', 'Whatsnew.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_4_manualClick(Sender: TObject);
{ displays the embedded instructions manual                                    }
begin
  ManualForm.Show;
end;





procedure TForm1.pm_6_configClick(Sender: TObject);
{ opens the "Config.ini" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Config.ini', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_7_keysClick(Sender: TObject);
{ displays the "key settings" form                                             }
begin
  KeysForm.position := poScreenCenter;
  KeysForm.visible := true;
  Form1.Enabled := false;
end;





procedure TForm1.pm_8_hiscoreClick(Sender: TObject);
{ resets high scores to the system registry                                    }
begin
  iHiScoreA := 0; iReg.WriteInteger('', 'HiScore1', iHiScoreA);
  iHiScoreP := 0; iReg.WriteInteger('', 'HiScore2', iHiScoreP);
  Beep;
end;





{}procedure TForm1.pm_10_fullscreenClick(Sender: TObject);
{ changes from fullscreen to windowed, and vice-versa                          }
begin
  // updates popup menu
  bFullscreenMode := not bFullscreenMode;
  pm_10_fullscreen.Checked := bFullscreenMode;
  bGameMenuOpen := false;

  iReg.WriteBool('', 'FullscreenMode', bFullscreenMode);

  // graphics init
  Top  := - Screen.Height;
  Left := - Screen.Width;
  Gfx_Game_Init;
  Position := poScreenCenter;
end;





procedure TForm1.pm_11_splashscreenClick(Sender: TObject);
{ updates the ticks to the checkbox, the popup menu and the system registry    }
begin
{}pm_11_splashscreen.Checked := not pm_11_splashscreen.Checked;

{}iReg.WriteBool('', 'SplashScreen', pm_11_splashscreen.Checked);
end;





procedure TForm1.pm_14_exitClick(Sender: TObject);
{ exits the game                                                               }
begin
  Application.Terminate;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.btn_game_menu_topClick(Sender: TObject);
{ sets the game menu as visible/hidden, then displays/hides it                 }
begin
  bGameMenuOpen := not bGameMenuOpen;
  Vid_Display_Game_Menu(bGameMenuOpen);
end;





procedure TForm1.la_menu_itemMouseEnter(Sender: TObject);
{ the game menu label bg colour becomes solid                                  }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := false;
end;





procedure TForm1.la_menu_itemMouseLeave(Sender: TObject);
{ the game menu label bg colour becomes transparent                            }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := true;
end;





procedure TForm1.la_menu_itemMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ hides the game menu, once a label has been pressed                           }
begin
  if Button = mbLeft then
    begin
      bGameMenuOpen := false;
      Vid_Display_Game_Menu(false);
    end;
end;





procedure TForm1.Vid_Display_Game_Menu(b: boolean);
{ displays/hides the game menu, depending on the value of bGameMenuOpen        }
  var
    i: integer;
begin
  case bGameMenuOpen of
    true: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i] := TLabel.Create(Form1);
            aMenuLabels[i].Parent := Form1;

            aMenuLabels[i].Top := 32 * i;
            aMenuLabels[i].Left := 0;

            aMenuLabels[i].AutoSize := false;
            aMenuLabels[i].Height := 32;
            aMenuLabels[i].Width := 256;
            aMenuLabels[i].Layout := tlCenter;

            aMenuLabels[i].Transparent := true;

            if aMenuItem[i].Caption <> '-' then
              begin
                aMenuLabels[i].Font.Name := 'Arial';
                aMenuLabels[i].Font.Color := clWhite;
                aMenuLabels[i].Font.Height := 16;
                aMenuLabels[i].Caption := '   ' + aMenuItem[i].Caption;

                if aMenuItem[i].Checked then
                  aMenuLabels[i].Caption := aMenuLabels[i].Caption + ' [V]';

                aMenuLabels[i].Color := $00000000;
                aMenuLabels[i].Cursor := crHandPoint;
                aMenuLabels[i].Enabled := aMenuItem[i].Enabled;

                if aMenuLabels[i].Enabled then
                  begin
                    aMenuLabels[i].OnClick      := aMenuItem[i].OnClick;
                    aMenuLabels[i].OnMouseEnter := la_menu_itemMouseEnter;
                    aMenuLabels[i].OnMouseLeave := la_menu_itemMouseLeave;
                    aMenuLabels[i].OnMouseUp    := la_menu_itemMouseUp;
                  end;
              end;
          end;

        btn_game_menu_background.Width := 256;
        btn_game_menu_background.Height := 32 * (MENU_ITEMS + 1)
      end;
    false: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i].Free;
          end;

        btn_game_menu_background.Height := 32;
        btn_game_menu_background.Width := 36;
      end;
    end; // case..of
end;





initialization
  bStartup := true;





end.
